CREATE TEMPORARY TABLE tmp_ss_ids (
  grouped_ids TEXT NOT NULL,
  min_id INT NOT NULL,
) TRANSACTIONAL AS
SELECT '|' || GROUP_CONCAT(id SEPARATOR '|') || '|' as ids, MIN(id)
 FROM seats_sample
 GROUP BY created_at, token_id, interval
 HAVING count(*) > 1;

CALL ls_run_until('
DELETE FROM seats_sample WHERE
  (SELECT COUNT(*) FROM tmp_ss_ids WHERE LOCATE(`|` || id || `|`, grouped_ids) > 0) > 0
  AND id NOT IN (SELECT min_id FROM tmp_ss_ids)
LIMIT 1000');

DROP TABLE tmp_ss_ids;
