$(function () {
  $(".uniquesButtton[data-url]").click(function (e) {
    e.preventDefault();

    var uniqueButton = $(this);

    return $.get(uniqueButton.data("url"), function (resp) {
      var respBody = $(resp),
          title = respBody.find("h1").html(),
          body = respBody.find(".content").html();

      uniqueButton.popover({
        html: true,
        trigger: 'manual',
        placement: 'bottom',
        title: title,
        content: body
      });
      uniqueButton.popover('show');
    });
  });
  // Click on 'X' - Closes without saving
  $(".popover-title .close").live('click', function () {
    $(".popover:visible").remove();
  });

  $(".popover:visible").live('click', function (e) {
    e.stopPropagation();
  });

  function popoverPreloader(object, toggle) {
    var closeButton = object.parents(".popover").find(".close");
    var preloader = closeButton.siblings(".preloader");
    if (toggle) {
      closeButton.hide();
      if (preloader.length === 0) {
        preloader = LS.common.preloaderImage().addClass("pull-right preloader");
        closeButton.after(preloader);
      }
      else {
        preloader.show();
      }
    }
    else {
      closeButton.show();
      preloader.hide();
    }
  }

  function submitAdvancedOptionsPopup(input) {
    var form = $(input);
    var id = form.find("[name='id']").val();

    LS.common.ajaxFormSubmit(form, function () {
      $(".uniquesButtton").popover('destroy');
      //Update page with new values

      //update subnet mask
      var subnetMask = form.find(".restrict-subnet").is(':checked') ? form.find("[name=subnetMask]").val().trim() : "";
      $("#subnetMask_" + id).html(!subnetMask ? "Any IP" : subnetMask);

      var productEl = $(".product[data-groupid='" + id + "']").html("");
      //update products list in table column
      form.find(".enable-token:checked")
      .map(function (idx, el) {
        return {name: el.dataset.longproductname, short: el.dataset.shortproductname};
      })
      .each(function (idx, el) {
        return $("<span />").addClass("no-wrap").attr("title", el.name)
        .text(el.short).append("<br />")
        .appendTo(productEl);
      });

    }, function (resp) {
      popoverPreloader(form, false);
      var errors = _.pairs($.parseJSON(resp.responseText));
      form.find(".alert-error").addClass("hide").html("");
      for (var index = 0; index < errors.length; ++index) {
        var div = form.find("div[name='" + errors[index][0] + "-error']");
        div.html(errors[index][1]);
        div.removeClass("hide");
      }
    },function () {
      popoverPreloader(form, true);
    }).submit();
  };

  // Click outside of pop-up - Save and Close
  $(document).click(function () {
    if ($(".popover").is(":visible")) {
      if ($('#IPAddressFilteringForm').length) {
        submitAdvancedOptionsPopup($("#IPAddressFilteringForm"));
      }
      else {
        $(".popover:visible").remove();
      }
      return false;
    }
  });

  //Restrict to number of users checkbox
  $("input.restrict-subnet").live('click', function () {
    var input = $(this).parents(".control-group:eq(0)").find("input:visible:not(:checkbox)");
    var restrict = $(this).is(":not(:checked)");
    input.attr("disabled", restrict);
  });

  //Restrict to number of users checkbox
  $("input.enable-token, input.restrict-token").live('change', function () {
    var tokenid = $(this).data().tokenid;
    var enableTokenCb = $(".enable-token[data-tokenid=" + tokenid + "]");
    var restrictTokenCb = $(".restrict-token[data-tokenid=" + tokenid + "]");
    restrictTokenCb.attr("disabled", enableTokenCb.is(":not(:checked)"));

    var input = $(".input-mini[data-tokenid=" + tokenid + "]");
    input.attr("disabled", enableTokenCb.is(":not(:checked)") || restrictTokenCb.is(":not(:checked)"));
  });

  //ESC - Closes without saving
  $(document).keyup(function(e) {
    if (e.keyCode === 27) {
      $('#sendTokenContent').modal('hide');
      $(".popover:visible").remove();
    }
  });

  //ENTER (on input field) - Save and Close
  $(".popover input[name=maxUsers], .popover input[name=subnetMask]").live('keydown', function (e) {
    if (e.keyCode === 13) {
      submitAdvancedOptionsPopup($("#IPAddressFilteringForm"));
      return false;
    }
  });

  $("#tokenChooser").change(function () {
    $("[id^=tokenUrl_]").hide();
    $("#tokenUrl_" + $(this).val()).css("display", 'inline');
  }).change();

  /// Invite license users form (emailTemplate.scala.html) ///
  $(".sendToken").click(function () {
    $.ajax({
      url: LS.routes.templateDataUrl,
      type: 'GET',
      data: {'id': $(this).data("group-id")}
    })
        .error(function(resp) {
          console.log("Request failed\n", resp)
        })
        .success(function (resp) {
          prepareModalWindow(resp);

          var modalEl = $("#sendTokenContent");
          modalEl.on('hide', function(){
            modalEl.removeClass('modal');
          }).modal('show').addClass('modal');

          var form = $("#sendTokenContent form[name='sendEmailTeam']");
          LS.common.ajaxFormSubmit(form, function () {
            modalEl.modal('hide');
          }, function (resp) {
            var errors = _.pairs($.parseJSON(resp.responseText));
            form.find(".alert").html(errors[0][1]).show();
            form.find(".fa-spinner").hide();
          },function () {
            modalEl.find(".alert").hide();
            disableButton(modalEl.find("form[name='sendEmailTeam']"));
            modalEl.find(".fa-spinner").show();
          });
        });
    return false;
  });

  $("input[name='newEmail'] + button").click(function(evt) {
    var valid = this.form.checkValidity();
    if (valid) {
      evt.preventDefault();
      addNewEmail($(this).siblings('input'));
    }
  });

  function addNewEmail(input) {
    var email = input.val().trim();
    var errorNode = input.parent().find('.alert');
    errorNode.hide();
    var form = $("form[name='addEmailTeam']");
    $.ajax({
      url: form.prop('action'),
      type: form.prop('method'),
      beforeSend: disableButton(form),
      complete: enableButton(form),
      data: {'email': email}
    })
    .error(function(resp) {
      errorNode.html(resp.responseText).show();
    })
    .success(function () {
      input.val('');
      addEmailToList(email);
    });
  }

  function prepareModalWindow(data) {
    var modal = $("#sendTokenContent");
    modal.find(".alert").hide();
    disableButton(modal.find("form[name='sendEmailTeam']"));
    modal.find("input[name='newEmail']").val('');
    modal.find(".fa-spinner").hide();
    $("#emails").empty();
    modal.find("form input[name='groupId']").val(data.id);
    modal.find(".team-invitation-header .team-name").text(data.name);
    modal.find("form textarea[name='content']").val(data.content);
  }

  function addEmailToList(newEmail) {
    enableButton($("#sendTokenContent form[name='sendEmailTeam']"));
    var emails = $("#emails");
    if (emails.find("input[value=\"" + newEmail + "\"]").length === 0) {
      emails.append($('<li>').append($('<span>').text(newEmail)).append($('<input type="hidden" name="emails[]"/>').val(newEmail))
          .append($('<a href="#" class="fa fa-times" aria-hidden="true"></a>').click(function (evt) {
        evt.preventDefault();
        $(this).parent().remove();
      })).append('</li>'));
    }
  }

  function enableButton(form) {
    form.find(':submit').removeAttr('disabled');
  }

  function disableButton(form) {
    form.find(':submit').attr('disabled','disabled');
  }
  /// Invite license users form (emailTemplate.scala.html) ///

  $("button.deactivation").click(function () {
    var modalEl = $(this).next();
    modalEl.on('hide', function(){
      modalEl.removeClass('modal');
    })
    .modal('show')
    .addClass('modal');
  });

  $("#licenseType").change(function() {
    var isFloating = (this.value === "0");
    var type = isFloating ? "LS_FLOATING" : "LS_MANAGED";

    $(".lictypes").attr("disabled", true);
    $(".lictypes." + type).attr("disabled", false);
    $(".lictypes.enable-token").toggle(!isFloating).attr("checked", true);

    // hide non JRebel products for floating group
    $(".productEntry").each(function(){
      var el = $(this);
      if (el.hasClass("JRebel")) {
        return;
      }
      if (el.hasClass("dummyCheckbox")) {
        el.toggle(isFloating);
      }
      else {
          el.toggle(!isFloating);
      }
    });

    $("form.add-group input.enable-token, form.add-group input.restrict-token").trigger("change");
  });
});
