// smtp settings
$(function (){
  $("#testConnection").click(function () {
    LS.common.testConnection($(this));
  });

  $("#testConnectionZt").click(function () {
    LS.common.testConnection($(this));
  });

  $(document).click(function () {
    $("#testConnection, .domainUsers").popover('destroy');
    $("#testConnectionZt, .domainUsers").popover('destroy');
  });

  $('#radio-mail-zt').click(function(){
    toggleDiv('div-mail-zt');
  });
  $('#radio-mail-smtp').click(function(){
    toggleDiv('div-mail-smtp');
  });

  function toggleDiv(theDivId) {
    document.getElementById("div-mail-zt").style.display = "none";
    document.getElementById("div-mail-smtp").style.display = "none";
    document.getElementById(theDivId).style.display = "block";
  }
});

// email verification settings
$(function (){

  var ongoingRequests = 0;

  function requestStarted() {
    requestCountChanged(++ongoingRequests);
  }
  function requestDone() {
    requestCountChanged(--ongoingRequests);
  }

  function requestCountChanged(count) {
    var headerEl = $("#emailVerificationBlock").find(".boxed-header");
    if (count === 0) {
      headerEl.find("i.fa").remove();
    }
    else if (count === 1){
      headerEl.find("h3")
        .append(LS.common.preloaderImage());
    }
  }

  function loadForm() {
    $('#emailVerificationBlock').find('form').submit(false);

    var form = $("form[name='emailSettings']");
    $.ajax({
      url: form.prop('action'),
      type: form.prop('method'),
      beforeSend: requestStarted,
      complete: requestDone
    })
    .success(function (data) {
      fillFormValues(form, data);
    });

  }

  function fillFormValues(form, data) {
    $("#allowedEmails").html('');
    $.each(data.emailDomains, function(idx, value) {
      addDomain(value);
    });
    $.each(data, function(key, value) {
      var el = form.find("input[name='"+ key +"']");
      if (el.prop('type') === 'checkbox') {
        el.prop('checked', !!value);
      }
      else {
        el.val(value);
      }
    });

    domainsChanged();
    showSettingsBlock();
  }

  loadForm();

  $("input[name='emailDomainVerification']").change(function() {
    showDomainsWarning();
  });

  $("input[name='rebelClientVerification']").change(function() {
    showSettingsBlock();
  });

  $("form[name='emailSettings'] input[name]").change(formChanged);

  $("input[data-name='newEmailDomain']").keypress(function(e) {
    if (e.which === 13) {
      addNewDomain($(this));
      return false;
    }
  });
  $("input[data-name='newEmailDomain'] + button").click(function() {
    var input = $(this).siblings('input');
    addNewDomain(input);
  });

  function addNewDomain(input) {
    var domain = input.val().trim();
    var errorNode = input.parent('label').find('.alert');

    errorNode.hide();
    var form = $("form[name='verifyEmailDomain']");
    $.ajax({
      url: form.prop('action'),
      type: form.prop('method'),
      data: {'domain': domain},
      beforeSend: requestStarted,
      complete: requestDone
    })
    .error(function(){
      errorNode.show();
    })
    .success(function () {
      input.val('');
      addDomain(domain);
      domainsChangedUi();
    });
  }

  function domainsChangedUi(){
    domainsChanged();
    formChanged();
  }

  function addDomain(domain) {
    $("#allowedEmails").append($('<li/>')
    .append($('<input name="emailDomains[]" readonly/>').val(domain))
    .append($('<i class="fa fa-close close"></i>')
      .click(function(evt) {
        evt.preventDefault();
        $(this).parent().remove();
        domainsChangedUi();
      })
    ));
    domainsChanged();
  }

  function domainsChanged() {
    showDomainsWarning();
  }

  function showSettingsBlock() {
    var show = $("input[name='rebelClientVerification']").is(':checked');
    var el = $('div.emailDomainSettingsBlock input:not([readonly]), div.emailDomainSettingsBlock button[name]');
    if (show) {
      el.removeProp('disabled');
    }
    else {
      el.prop('disabled', 'disabled');
    }
  }

  function showDomainsWarning() {
    var show = $("input[name='emailDomainVerification']").is(':checked')
      && $('#allowedEmails').find('li').length === 0;
    var el = $('#missing-domains-notice');
    if (show) {
      el.show();
    }
    else {
      el.hide();
    }
  }

  function formChanged() {
    var formData = $("form[name='emailSettings']").clone();
    console.log("form: ", formData.serialize());
    var form = $("form[name='saveEmailSettings']");
    $.ajax({
      url: form.prop('action'),
      type: form.prop('method'),
      data: formData.serialize(),
      beforeSend: requestStarted,
      complete: requestDone
    })
    .success(function (data) {
      console.log('saved: ', data);
      fillFormValues(formData, data);
    });
  }
});


